diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 829bebe08..58afeae82 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -10,7 +10,7 @@ import net.minecraft.core.block.BlockLogicOreLapis;
 import net.minecraft.core.block.BlockLogicOreRedstone;
 import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldTypes;
@@ -79,10 +79,10 @@ public class ChunkDecoratorOverworld
                             int negZId = this.world.getBlockId(x + dx, topBlock - 1, z + dz - 1);
                             int negYId = this.world.getBlockId(x + dx, topBlock - 2, z + dz);
                             if (
-                                posXId != 0 && (Blocks.blocksList[posXId].getMaterial().isSolid() || Blocks.blocksList[posXId].getMaterial() == Material.water) &&
-                                    negXId != 0 && (Blocks.blocksList[negXId].getMaterial().isSolid() || Blocks.blocksList[negXId].getMaterial() == Material.water) &&
-                                    posZId != 0 && (Blocks.blocksList[posZId].getMaterial().isSolid() || Blocks.blocksList[posZId].getMaterial() == Material.water) &&
-                                    negZId != 0 && (Blocks.blocksList[negZId].getMaterial().isSolid() || Blocks.blocksList[negZId].getMaterial() == Material.water) &&
+                                posXId != 0 && (Blocks.blocksList[posXId].getMaterial().isSolid() || Blocks.blocksList[posXId].getMaterial() == Materials.WATER) &&
+                                    negXId != 0 && (Blocks.blocksList[negXId].getMaterial().isSolid() || Blocks.blocksList[negXId].getMaterial() == Materials.WATER) &&
+                                    posZId != 0 && (Blocks.blocksList[posZId].getMaterial().isSolid() || Blocks.blocksList[posZId].getMaterial() == Materials.WATER) &&
+                                    negZId != 0 && (Blocks.blocksList[negZId].getMaterial().isSolid() || Blocks.blocksList[negZId].getMaterial() == Materials.WATER) &&
                                     negYId != 0 && Blocks.blocksList[negYId].getMaterial().isSolid()
                             ) {
                                 this.world.setBlock(x + dx, topBlock - 1, z + dz, Blocks.FLUID_WATER_STILL.id());
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index 2522b96fe..ab9769f6e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -7,7 +7,7 @@ import net.minecraft.core.block.BlockLogicOreIron;
 import net.minecraft.core.block.BlockLogicOreRedstone;
 import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
@@ -189,10 +189,10 @@ public class ChunkDecoratorOverworldRetro
         for (int l10 = k + 8; l10 < k + 8 + 16; l10++) {
             for (int k15 = l + 8; k15 < l + 8 + 16; k15++) {
                 int i18 = this.world.findTopSolidBlock(l10, k15);
-                if (this.snowCovered && i18 > minY && i18 <= maxY && this.world.getBlockId(l10, i18, k15) == 0 && this.world.getBlockMaterial(l10, i18 - 1, k15).blocksMotion() && this.world.getBlockMaterial(l10, i18 - 1, k15) != Material.ice) {
+                if (this.snowCovered && i18 > minY && i18 <= maxY && this.world.getBlockId(l10, i18, k15) == 0 && this.world.getBlockMaterial(l10, i18 - 1, k15).blocksMotion() && this.world.getBlockMaterial(l10, i18 - 1, k15) != Materials.ICE) {
                     this.world.setBlockWithNotify(l10, i18, k15, Blocks.LAYER_SNOW.id());
                 }
-                if (this.snowCovered && this.world.getBlockMaterial(l10, this.world.getWorldType().getOceanY() - 1, k15) == Material.water) {
+                if (this.snowCovered && this.world.getBlockMaterial(l10, this.world.getWorldType().getOceanY() - 1, k15) == Materials.WATER) {
                     this.world.setBlockWithNotify(l10, this.world.getWorldType().getOceanY() - 1, k15, Blocks.ICE.id());
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
index 678b53444..63244bdcc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -18,7 +18,7 @@ public class WorldFeatureAlgae extends WorldFeature
             int j1 = (y);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
             if((world.getBlockId(i1, j1, k1) == Blocks.FLUID_WATER_STILL.id()) &&
-                    world.getBlockMaterial(i1, j1+1, k1) == Material.air)
+                    world.getBlockMaterial(i1, j1+1, k1) == Materials.AIR)
             {
                 world.setBlock(i1, j1+1, k1, Blocks.ALGAE.id());
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
index 16486fda5..0e9bdb017 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
@@ -2,7 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
@@ -28,7 +28,7 @@ public class WorldFeatureClay extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockMaterial(x, y, z) != Material.water)
+        if(world.getBlockMaterial(x, y, z) != Materials.WATER)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
index f69886b97..3e7b5eeac 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
@@ -16,69 +16,60 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class WorldFeatureDungeon extends WorldFeature
-{
-	public int blockIdWalls;
-	public int blockIdFloor;
-	public @Nullable String mobOverride;
+public class WorldFeatureDungeon extends WorldFeature {
+    public int blockIdWalls;
+    public int blockIdFloor;
+    public @Nullable String mobOverride;
     public WeightedRandomBag<WeightedRandomLootObject> chestLoot;
     public WeightedRandomBag<String> spawnerMonsters;
 
     @MethodParametersAnnotation(names = {"blockIdWalls", "blockIdFloor", "mobOverrideDispatcherId"})
-    public WorldFeatureDungeon(int blockIdWalls, int blockIdFloor, @Nullable String mobOverride)
-    {
-    	this.blockIdWalls = blockIdWalls;
-    	this.blockIdFloor = blockIdFloor;
-    	this.mobOverride = mobOverride;
+    public WorldFeatureDungeon(int blockIdWalls, int blockIdFloor, @Nullable String mobOverride) {
+        this.blockIdWalls = blockIdWalls;
+        this.blockIdFloor = blockIdFloor;
+        this.mobOverride = mobOverride;
         this.chestLoot = new WeightedRandomBag<>();
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.SADDLE.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_IRON.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_BREAD.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.WHEAT.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.STRING.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.BUCKET.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE_GOLD.getDefaultStack()), 1);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.DUST_REDSTONE.getDefaultStack(), 1, 4), 50);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.SADDLE.getDefaultStack()), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_IRON.getDefaultStack(), 1, 4), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_BREAD.getDefaultStack()), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.WHEAT.getDefaultStack(), 1, 4), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 1, 4), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.STRING.getDefaultStack(), 1, 4), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.BUCKET.getDefaultStack()), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE_GOLD.getDefaultStack()), 1);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.DUST_REDSTONE.getDefaultStack(), 1, 4), 50);
         for (int i = 0; i < 9; i++) {
-            chestLoot.addEntry(new WeightedRandomLootObject(new ItemStack(Item.itemsList[Items.RECORD_13.id + i]), 1), 1);
+            this.chestLoot.addEntry(new WeightedRandomLootObject(new ItemStack(Item.itemsList[Items.RECORD_13.id + i]), 1), 1);
         }
-        chestLoot.addEntry(new WeightedRandomLootObject(Blocks.SAPLING_CACAO.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Blocks.SPONGE_DRY.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 1, 4), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE.getDefaultStack()), 100);
-        chestLoot.addEntry(new WeightedRandomLootObject(null),239);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Blocks.SAPLING_CACAO.getDefaultStack()), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Blocks.SPONGE_DRY.getDefaultStack(), 1, 4), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 1, 4), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(Items.FOOD_APPLE.getDefaultStack()), 100);
+        this.chestLoot.addEntry(new WeightedRandomLootObject(null), 239);
 
         this.spawnerMonsters = new WeightedRandomBag<>();
-        spawnerMonsters.addEntry("Skeleton", 1);
-        spawnerMonsters.addEntry("Zombie", 2);
-        spawnerMonsters.addEntry("Spider", 1);
+        this.spawnerMonsters.addEntry("Skeleton", 1);
+        this.spawnerMonsters.addEntry("Zombie", 2);
+        this.spawnerMonsters.addEntry("Spider", 1);
     }
 
     @Override
-	public boolean place(World world, Random random, int x, int y, int z)
-    {
+    public boolean place(World world, Random random, int x, int y, int z) {
         byte height = 3;
         int width = random.nextInt(2) + 2;
         int length = random.nextInt(2) + 2;
         int j1 = 0;
-        for(int k1 = x - width - 1; k1 <= x + width + 1; k1++)
-        {
-            for(int j2 = y - 1; j2 <= y + height + 1; j2++)
-            {
-                for(int i3 = z - length - 1; i3 <= z + length + 1; i3++)
-                {
+        for (int k1 = x - width - 1; k1 <= x + width + 1; k1++) {
+            for (int j2 = y - 1; j2 <= y + height + 1; j2++) {
+                for (int i3 = z - length - 1; i3 <= z + length + 1; i3++) {
                     Material material = world.getBlockMaterial(k1, j2, i3);
-                    if(j2 == y - 1 && !material.isSolid())
-                    {
+                    if (j2 == y - 1 && !material.isSolid()) {
                         return false;
                     }
-                    if(j2 == y + height + 1 && !material.isSolid())
-                    {
+                    if (j2 == y + height + 1 && !material.isSolid()) {
                         return false;
                     }
-                    if((k1 == x - width - 1 || k1 == x + width + 1 || i3 == z - length - 1 || i3 == z + length + 1) && j2 == y && world.isAirBlock(k1, j2, i3) && world.isAirBlock(k1, j2 + 1, i3))
-                    {
+                    if ((k1 == x - width - 1 || k1 == x + width + 1 || i3 == z - length - 1 || i3 == z + length + 1) && j2 == y && world.isAirBlock(k1, j2, i3) && world.isAirBlock(k1, j2 + 1, i3)) {
                         j1++;
                     }
                 }
@@ -87,34 +78,26 @@ public class WorldFeatureDungeon extends WorldFeature
 
         }
 
-        if(j1 < 1 || j1 > 5)
-        {
+        if (j1 < 1 || j1 > 5) {
             return false;
         }
-        for(int l1 = x - width - 1; l1 <= x + width + 1; l1++)
-        {
-            for(int k2 = y + height; k2 >= y - 1; k2--)
-            {
-                for(int j3 = z - length - 1; j3 <= z + length + 1; j3++)
-                {
-                    if(l1 == x - width - 1 || k2 == y - 1 || j3 == z - length - 1 || l1 == x + width + 1 || k2 == y + height + 1 || j3 == z + length + 1)
-                    {
-                        if(k2 >= 0 && !world.getBlockMaterial(l1, k2 - 1, j3).isSolid())
-                        {
+        for (int l1 = x - width - 1; l1 <= x + width + 1; l1++) {
+            for (int k2 = y + height; k2 >= y - 1; k2--) {
+                for (int j3 = z - length - 1; j3 <= z + length + 1; j3++) {
+                    if (l1 == x - width - 1 || k2 == y - 1 || j3 == z - length - 1 || l1 == x + width + 1 || k2 == y + height + 1 || j3 == z + length + 1) {
+                        if (k2 >= 0 && !world.getBlockMaterial(l1, k2 - 1, j3).isSolid()) {
                             world.setBlockWithNotify(l1, k2, j3, 0);
                             continue;
                         }
-                        if(!world.getBlockMaterial(l1, k2, j3).isSolid())
-                        {
+                        if (!world.getBlockMaterial(l1, k2, j3).isSolid()) {
                             continue;
                         }
                         if (k2 == y - 1 && random.nextInt(4) != 0) {
-                            world.setBlockWithNotify(l1, k2, j3, blockIdFloor);
+                            world.setBlockWithNotify(l1, k2, j3, this.blockIdFloor);
                         } else {
-                            world.setBlockWithNotify(l1, k2, j3, blockIdWalls);
+                            world.setBlockWithNotify(l1, k2, j3, this.blockIdWalls);
                         }
-                    } else
-                    {
+                    } else {
                         world.setBlockWithNotify(l1, k2, j3, 0);
                     }
                 }
@@ -123,75 +106,63 @@ public class WorldFeatureDungeon extends WorldFeature
 
         }
 
-        for(int i2 = 0; i2 < 2; i2++)
-        {
+        for (int i2 = 0; i2 < 2; i2++) {
             label0:
-            for(int l2 = 0; l2 < 3; l2++)
-            {
+            for (int l2 = 0; l2 < 3; l2++) {
                 int k3 = (x + random.nextInt(width * 2 + 1)) - width;
                 int l3 = y;
                 int i4 = (z + random.nextInt(length * 2 + 1)) - length;
-                if(!world.isAirBlock(k3, l3, i4))
-                {
+                if (!world.isAirBlock(k3, l3, i4)) {
                     continue;
                 }
                 int j4 = 0;
-                if(world.getBlockMaterial(k3 - 1, l3, i4).isSolid())
-                {
+                if (world.getBlockMaterial(k3 - 1, l3, i4).isSolid()) {
                     j4++;
                 }
-                if(world.getBlockMaterial(k3 + 1, l3, i4).isSolid())
-                {
+                if (world.getBlockMaterial(k3 + 1, l3, i4).isSolid()) {
                     j4++;
                 }
-                if(world.getBlockMaterial(k3, l3, i4 - 1).isSolid())
-                {
+                if (world.getBlockMaterial(k3, l3, i4 - 1).isSolid()) {
                     j4++;
                 }
-                if(world.getBlockMaterial(k3, l3, i4 + 1).isSolid())
-                {
+                if (world.getBlockMaterial(k3, l3, i4 + 1).isSolid()) {
                     j4++;
                 }
-                if(j4 != 1)
-                {
+                if (j4 != 1) {
                     continue;
                 }
                 world.setBlockWithNotify(k3, l3, i4, Blocks.CHEST_PLANKS_OAK.id());
                 BlockLogicChest.setDefaultDirection(world, new TilePos(k3, l3, i4));
-                TileEntityChest tileentitychest = (TileEntityChest)world.getTileEntity(k3, l3, i4);
+                TileEntityChest tileentitychest = (TileEntityChest) world.getTileEntity(k3, l3, i4);
                 int k4 = 0;
-                do
-                {
-                    if(k4 >= 8)
-                    {
+                do {
+                    if (k4 >= 8) {
                         break label0;
                     }
                     ItemStack itemstack = pickCheckLootItem(random);
-                    if(itemstack != null)
-                    {
+                    if (itemstack != null) {
                         tileentitychest.setItem(random.nextInt(tileentitychest.getContainerSize()), itemstack);
                     }
                     k4++;
-                } while(true);
+                } while (true);
             }
 
         }
 
         world.setBlockWithNotify(x, y, z, Blocks.MOBSPAWNER.id());
-        TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getTileEntity(x, y, z);
-        tileentitymobspawner.setMobId(pickMobSpawner(random));
+        if (world.getTileEntity(x, y, z) instanceof TileEntityMobSpawner spawner) {
+            spawner.setMobId(pickMobSpawner(random));
+        }
         return true;
     }
 
-    private ItemStack pickCheckLootItem(Random random)
-    {
-        return chestLoot.getRandom(random).getItemStack(random);
+    private ItemStack pickCheckLootItem(Random random) {
+        return this.chestLoot.getRandom(random).getItemStack(random);
     }
 
-    private String pickMobSpawner(Random random)
-    {
-    	if (mobOverride != null) return mobOverride;
+    private String pickMobSpawner(Random random) {
+        if (this.mobOverride != null) return this.mobOverride;
 
-        return spawnerMonsters.getRandom(random);
+        return this.spawnerMonsters.getRandom(random);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index f93de58ab..ba9b554b7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.block.entity.TileEntityStatue;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IArmorItem;
@@ -17,7 +18,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.Nullable;
@@ -273,11 +273,11 @@ public class WorldFeatureLabyrinth extends WorldFeature
             return true;
         }
         return BlockTags.CAVES_CUT_THROUGH.appliesTo(world.getBlock(x, y, z)) ||
-                world.getBlockMaterial(x, y, z) == Material.grass ||
-                world.getBlockMaterial(x, y, z) == Material.dirt ||
+                world.getBlockMaterial(x, y, z) == Materials.GRASS ||
+                world.getBlockMaterial(x, y, z) == Materials.DIRT ||
                 world.getBlockMaterial(x, y, z).isStone() ||
-                world.getBlockMaterial(x, y, z) == Material.sand ||
-                world.getBlockMaterial(x, y, z) == Material.moss;
+                world.getBlockMaterial(x, y, z) == Materials.SAND ||
+                world.getBlockMaterial(x, y, z) == Materials.MOSS;
     }
 
     private void generateCorridor(World world, Random random, int blockX, int blockY, int blockZ, int rot, int corridorIteration){
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
index 85462cd05..cc3538cc8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
@@ -118,7 +119,7 @@ public class WorldFeatureLake extends WorldFeature
 
         }
 
-        if(Blocks.blocksList[liquidId].getMaterial() == Material.lava)
+        if(Blocks.blocksList[liquidId].getMaterial() == Materials.LAVA)
         {
             for(int dx = 0; dx < 16; dx++)
             {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
index 759a6fc2c..d0e2e3746 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
@@ -2,7 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
@@ -26,7 +26,7 @@ public class WorldFeaturePumice extends WorldFeature{
     @Override
     public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockMaterial(x, y, z) != Material.lava || world.getBlockId(x, y + 1, z) != 0)
+        if(world.getBlockMaterial(x, y, z) != Materials.LAVA || world.getBlockId(x, y + 1, z) != 0)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
index 26491dc96..87a76fc66 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -21,7 +21,7 @@ public class WorldFeatureSugarCane extends WorldFeature
             int i1 = (x + random.nextInt(4)) - random.nextInt(4);
             int j1 = y;
             int k1 = (z + random.nextInt(4)) - random.nextInt(4);
-            if(!world.isAirBlock(i1, j1, k1) || world.getBlockMaterial(i1 - 1, j1 - 1, k1) != Material.water && world.getBlockMaterial(i1 + 1, j1 - 1, k1) != Material.water && world.getBlockMaterial(i1, j1 - 1, k1 - 1) != Material.water && world.getBlockMaterial(i1, j1 - 1, k1 + 1) != Material.water)
+            if(!world.isAirBlock(i1, j1, k1) || world.getBlockMaterial(i1 - 1, j1 - 1, k1) != Materials.WATER && world.getBlockMaterial(i1 + 1, j1 - 1, k1) != Materials.WATER && world.getBlockMaterial(i1, j1 - 1, k1 - 1) != Materials.WATER && world.getBlockMaterial(i1, j1 - 1, k1 + 1) != Materials.WATER)
             {
                 continue;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
index ad169f975..b4a282cd9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -21,7 +21,7 @@ public class WorldFeatureSugarCaneTall extends WorldFeature
             int i1 = (x + random.nextInt(4)) - random.nextInt(4);
             int j1 = y;
             int k1 = (z + random.nextInt(4)) - random.nextInt(4);
-            if(!world.isAirBlock(i1, j1, k1) || world.getBlockMaterial(i1 - 1, j1 - 1, k1) != Material.water && world.getBlockMaterial(i1 + 1, j1 - 1, k1) != Material.water && world.getBlockMaterial(i1, j1 - 1, k1 - 1) != Material.water && world.getBlockMaterial(i1, j1 - 1, k1 + 1) != Material.water)
+            if(!world.isAirBlock(i1, j1, k1) || world.getBlockMaterial(i1 - 1, j1 - 1, k1) != Materials.WATER && world.getBlockMaterial(i1 + 1, j1 - 1, k1) != Materials.WATER && world.getBlockMaterial(i1, j1 - 1, k1 - 1) != Materials.WATER && world.getBlockMaterial(i1, j1 - 1, k1 + 1) != Materials.WATER)
             {
                 continue;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java
index 2b349dafd..905f8d446 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java
@@ -1,47 +1,41 @@
 package net.minecraft.core.world.pathfinder;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
-public class Path
-{
+public class Path {
     private final Node[] nodes;
     public final int length;
     private int index;
 
-    public Path(Node[] nodes)
-    {
+    public Path(Node[] nodes) {
         this.nodes = nodes;
-        length = nodes.length;
+        this.length = nodes.length;
     }
 
-    public void next()
-    {
-        index++;
+    public void next() {
+        this.index++;
     }
 
-    public boolean isDone()
-    {
-        return index >= nodes.length;
+    public boolean isDone() {
+        return this.index >= this.nodes.length;
     }
 
-    public Node last()
-    {
-        if(length > 0)
-        {
-            return nodes[length - 1];
-        }
-        else
-        {
+    public Node last() {
+        if (this.length > 0) {
+            return this.nodes[this.length - 1];
+        } else {
             return null;
         }
     }
 
-    public Vec3 getPos(Entity entity)
-    {
-        double x = (double) nodes[index].x + (double)(int)(entity.bbWidth + 2.0F) * 0.5D;
-        double y = nodes[index].y;
-        double z = (double) nodes[index].z + (double)(int)(entity.bbWidth + 2.0F) * 0.5D;
-        return Vec3.fromPool(x, y, z);
+    public @Nullable Vector3dc getPos(@NotNull Entity entity) {
+        double x = (double) this.nodes[this.index].x + (double) (int) (entity.bbWidth + 2.0F) * 0.5D;
+        double y = this.nodes[this.index].y;
+        double z = (double) this.nodes[this.index].z + (double) (int) (entity.bbWidth + 2.0F) * 0.5D;
+        return new Vector3d(x, y, z);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index fdc7611ee..4448dc7ea 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -1,16 +1,14 @@
 package net.minecraft.core.world.pathfinder;
 
-import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
-import it.unimi.dsi.fastutil.ints.Int2ObjectLinkedOpenHashMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.block.BlockLogicTrapDoor;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.monster.MobCreeper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.WorldSource;
@@ -222,11 +220,11 @@ public class PathFinder
                     {
                         return 0;
                     }
-                    if(material == Material.water)
+                    if(material == Materials.WATER)
                     {
                         return -1;
                     }
-                    if(material == Material.lava)
+                    if(material == Materials.LAVA)
                     {
                         return -2;
                     }
